Package com.io7m.jtensors.orthonormalization

# Class Orthonormalized3D

java.lang.Object
com.io7m.jtensors.orthonormalization.Orthonormalized3D

All Implemented Interfaces:
  `Orthonormalized3DType`

    public final class Orthonormalized3D
    extends java.lang.Object
    implements Orthonormalized3DType

A set of vectors that are orthogonal to each other and are normalized.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `Orthonormalized3D.Builder` | Builds instances of type `Orthonormalized3D`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static Orthonormalized3D.Builder` | `builder()` | Creates a builder for `Orthonormalized3D`.
  `static Orthonormalized3D` | `copyOf​(Orthonormalized3DType instance)` | Creates an immutable copy of a `Orthonormalized3DType` value.
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `Orthonormalized3D` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `v0`, `v1`, `v2`.
  `static Orthonormalized3D` | `of​(Vector3D v0, Vector3D v1, Vector3D v2)` | Construct a new immutable `Orthonormalized3D` instance.
  `java.lang.String` | `toString()` | Prints the immutable value `Orthonormalized3D` with attribute values.
  `Vector3D` | `v0()` |
  `Vector3D` | `v1()` |
  `Vector3D` | `v2()` |
  `Orthonormalized3D` | `withV0​(Vector3D value)` | Copy the current immutable object by setting a value for the `v0` attribute.
  `Orthonormalized3D` | `withV1​(Vector3D value)` | Copy the current immutable object by setting a value for the `v1` attribute.
  `Orthonormalized3D` | `withV2​(Vector3D value)` | Copy the current immutable object by setting a value for the `v2` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### v0

    public Vector3D v0()
    Specified by:
      `v0` in interface `Orthonormalized3DType`
    Returns:
      Vector 0

  - ### v1

    public Vector3D v1()
    Specified by:
      `v1` in interface `Orthonormalized3DType`
    Returns:
      Vector 1

  - ### v2

    public Vector3D v2()
    Specified by:
      `v2` in interface `Orthonormalized3DType`
    Returns:
      Vector 2

  - ### withV0

    public final Orthonormalized3D withV0​(Vector3D value)
    Copy the current immutable object by setting a value for the `v0` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for v0
    Returns:
      A modified copy of the `this` object

  - ### withV1

    public final Orthonormalized3D withV1​(Vector3D value)
    Copy the current immutable object by setting a value for the `v1` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for v1
    Returns:
      A modified copy of the `this` object

  - ### withV2

    public final Orthonormalized3D withV2​(Vector3D value)
    Copy the current immutable object by setting a value for the `v2` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for v2
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `Orthonormalized3D` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `v0`, `v1`, `v2`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `Orthonormalized3D` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### of

    public static Orthonormalized3D of​(Vector3D v0, Vector3D v1, Vector3D v2)
    Construct a new immutable `Orthonormalized3D` instance.
    Parameters:
      `v0` - The value for the `v0` attribute
      `v1` - The value for the `v1` attribute
      `v2` - The value for the `v2` attribute
    Returns:
      An immutable Orthonormalized3D instance

  - ### copyOf

    public static Orthonormalized3D copyOf​(Orthonormalized3DType instance)
    Creates an immutable copy of a `Orthonormalized3DType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable Orthonormalized3D instance

  - ### builder

    public static Orthonormalized3D.Builder builder()
    Creates a builder for `Orthonormalized3D`.

         Orthonormalized3D.builder()
            .setV0(com.io7m.jtensors.core.unparameterized.vectors.Vector3D) // required v0
            .setV1(com.io7m.jtensors.core.unparameterized.vectors.Vector3D) // required v1
            .setV2(com.io7m.jtensors.core.unparameterized.vectors.Vector3D) // required v2
            .build();

    Returns:
      A new Orthonormalized3D builder